/////////////////////////////////////////////////////////////////////////
//Horseshoe-Umkehr-Map visualisieren für anzahlStartP, zufällige Startpunkte
//Linker Maus-Klick: Nächste Iteration durchführen
//Rechter Maus-Klick: Zoomen von x-Werten im Bereich des unteren Sechstels
//Bei a=600 ohne Zoom sinnvoll bis ca. 5.Iteration
//Mit Zoom 144-fach etwa bis 10.Iteration und weiter....
//Wählt man für die Anzahl der Startpunkte einen größeren Wert als 100 000,
//dann kommt man noch deutlich weiter...
//Die Geschwindigkeit des Programms wurde deutlich vergrößert, indem 
//für jeden abgebildeten Punkt gleich die ganze waagerechte Gerade
//eingezeichnet wurde. Dieses Vorgehen ist mathematisch sinnvoll, weil
//für jeden x-Wert alle Punkte mit diesem Wert in der abgebildeten Menge 
//enthalten sind.
//////////////////////////////////////////////////////////////////////

float a = 600 ;//Bildbreite/höhe
float x,y;//Hilfsvariable
float xAlt,yAlt,xNeu,yNeu;//Iterationsvariable
int anzahlItAkt = 0;//zum zählen der Iterationen
int anzahlIt = 1;//Anzahl der Iterationen
int anzahlStartP = 20000;//Anzahl der Startpunkte
float xUMap, xOMap; //Zu zeichnender x-Bereich
////////////////////////////////////////////////////////////////
void setup(){
  size(600,600);   
   xUMap = 0;
   xOMap = a;
   abbilden();
}
//////////////////////////////////////////////////////////////////
void draw(){
 
//braucht man für Mausklicks...   
}


/////////////////////////////////////////////////////

void abbilden(){
  background(0);
   smooth();
   textSize(12);
  x = 0; y=0;//initialisieren
 
  for(int i=0; i<anzahlStartP;i++){
   xAlt = random(0,a);
   yAlt = random(0,a);
   hufeisenAbb(xAlt,yAlt);
  }     
}
///////////////////////////////////////////////////
void hufeisenAbb(float x, float y){
   this.x =x;
   this.y =y;
   stroke(255);
   strokeWeight(1);
   anzahlItAkt =0;
  
   xAlt = x;
   yAlt = y;
   text("Zoomfaktor = "+a/xOMap, a/2-35,20);
   text(anzahlIt+". Iteration ", a/2-35, 40);
    
   iterieren();
  
}
////////////////////////////////////////////////////////////
void iterieren(){

   if(yAlt <a/3){
      
         xNeu = xAlt/3;
         yNeu = 3*yAlt;     
         xAlt = xNeu;
         yAlt = yNeu;
         anzahlItAkt++;   
        if(anzahlItAkt <anzahlIt ) {
             
            iterieren();          
         }else{  
           xAlt = map((float)xAlt, xUMap, xOMap, 0,a);
            stroke(134,173,252);// taubenblau
           line(xAlt,0,xAlt,a);
          // point((float)xAlt,(float)yAlt);
         }
       }
    else if(yAlt >2*a/3){
     
         xNeu = a-xAlt/3;
         yNeu = 3*a-3*yAlt;      
         xAlt = xNeu;
         yAlt = yNeu;
         anzahlItAkt++;          
         if(anzahlItAkt <anzahlIt) {
           
            iterieren();          
         }else{
            xAlt = map((float)xAlt, xUMap, xOMap, 0,a);
             stroke(230,0,0);// rot
            line(xAlt,0,xAlt,a);
            //point((float)xAlt,(float)yAlt);  
          }
    }
      
}

////////////////////////////////////////////////////////////////////////
void mousePressed() { 
  if(mouseButton == LEFT){//nächste Iteration
      anzahlIt++;
      abbilden();
  }
   if(mouseButton == RIGHT){
      xOMap = xOMap/2;
      anzahlStartP = anzahlStartP *2;
      abbilden();
  }  
  
}
